#include <iostream>
#include <iomanip>
#include <cmath>
#include<ctime>

using namespace std;


/* Priklad: secteni dvou matic a vypsani vysledku */
void priklad1()
{
	int a[3][2] = { {1,0},{0,-1},{0,1} };
	int b[3][2] = { {-1,-2},{0,3},{-5,2} };
	int c[3][2];     // vysledek souctu

	// soucet matic
	for (int i = 0; i < 3; i++)
		for (int j = 0; j < 2; j++)
			c[i][j] = a[i][j] + b[i][j];

	// vypis vysledku
	for (int i = 0; i < 3; i++)
	{
		for (int j = 0; j < 2; j++)
			cout << setw(3) << c[i][j] << " ";
		cout << endl;
	}
}

/* Priklad: vynasobeni dvou matic a vypsani vysledku */
void priklad2()
{
	int a[3][2] = { {1,0},{0,-1},{0,1} };
	int b[2][4] = { {0,1,0,0},{0,-1,-1,0} };
	int c[3][4];     // vysledek soucinu

	// soucin matic
	for (int i = 0; i < 3; i++)
		for (int j = 0; j < 4; j++)
		{
			c[i][j] = 0;
			for (int k = 0; k < 2; k++)
				c[i][j] += a[i][k] * b[k][j];
		}

	// vypis vysledku
	for (int i = 0; i < 3; i++)
	{
		for (int j = 0; j < 4; j++)
			cout << setw(3) << c[i][j] << " ";
		cout << endl;
	}
}

/* Algoritmus Eratosthenova sito pro vypsani vsech prvocisel az do cisla 500 */
void sito()
{
	const int n = 500;
	bool tabulka[n + 1];
	int i, j;
	tabulka[0] = false;
	tabulka[1] = false;

	// inicializuj
	for (int i = 2; i <= n; i++)
		tabulka[i] = true;

	//vypocitej
	for (i = 2; i * i <= n; i++)
		if (tabulka[i])
			for (j = i * i; j <= n; j += i)
				tabulka[j] = false;

	// vypis
	for (int i = 2; i <= n; i++)
		if (tabulka[i])
			cout << i << ' ';
	cout << endl;
}

/* Funkce prohodi v poli a prvky na indexech i a j. */
void prohod(double *a, int i, int j)
{
	double pom = a[i];
	a[i] = a[j];
	a[j] = pom;
}

/* Vypis vsech prvku pole a delky n na konzoli. */
void vypis(const double *a, int n)
{
	for (int i = 0; i < n; i++)
		cout << a[i] << " ";
	cout << endl;
}

/* Funkce setridi pole a delky n metodou bublinkoveho trideni. */
void setridBublinky(double *a, int delka)
{
	for (int i = 1; i < delka; i++)
	{
		for (int j = 0; j < delka - 1; j++)
		{
			if (a[j + 1] < a[j])
				prohod(a, j, j + 1);
		}
	}
}

/* Funkce setridi pole a delky n metodou bublinkoveho trideni. */
void setridBublinky1(double *a, int delka)
{
	for (int i = delka - 1; i >= 1; i--)
	{
		for (int j = 0; j < i; j++)
		{
			if (a[j + 1] < a[j])
				prohod(a, j, j + 1);
		}
	}
}

int main()
{
	priklad1();
	priklad2();
	sito();

	{
		double a[10] = { 7,2,7,-4.1, 7.8, 8, 9.8, -5.8, 2 - 10 };
		vypis(a, 10);
		setridBublinky(a, 10);
		vypis(a, 10);
	}

	{
		double a[10] = { 7,2,7,-4.1, 7.8, 8, 9.8, -5.8, 2 - 10 };
		vypis(a, 10);
		setridBublinky1(a, 10);
		vypis(a, 10);
	}
	return 0;
}